diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index 97fd15cfb..3c4dd0830 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -206,6 +206,11 @@ gui.options.page.language_packs.title=Language Packs
 gui.options.page.language_packs.category.language_packs=Language Packs
 gui.options.page.language_packs.button.open_folder=Open Folder
 
+gui.options.page.debug.title=Debug Menu
+gui.options.page.debug.button.open.model_viewer=Open Model Viewer
+gui.options.page.debug.button.open.biome_finder=Open Biome Finder
+gui.options.page.debug.button.open.datadumper=Run Data Dumper
+
 gui.options.page.search.title=Search
 
 gui.photo_mode.label.mouse_hint=Click and drag to move and rotate.
@@ -282,3 +287,43 @@ gui.trommel.label.inventory=Inventory
 gui.hud_designer.button.done=Done
 
 gui.pick_monster.label.title=Select mob to spawn
+
+gui.model_viewer.slider.variant=Variant: %d
+gui.model_viewer.slider.meta=Meta: %d
+gui.model_viewer.button.tickprogress=Run Tick: %s
+gui.model_viewer.button.rotate=Rotate Labels: %s
+gui.model_viewer.button.reload_textures=Reload Textures
+
+gui.model_viewer.button.category=Category
+
+model.category.entity.info=Entity: %s
+model.category.entity.name=Entity
+model.category.entity.tnt.slider.fuse=Fuse: %d
+model.category.entity.sheep.slider.color=Color: %s
+model.category.entity.painting.slider.motif=Painting: %s
+model.category.entity.fireflycluster.slider.size=Size: %d
+model.category.entity.fireflycluster.button.cycle=Color: %s
+model.category.entity.item.button.cycle=Cycle Item
+model.category.entity.item.slider.size=Size: %d
+model.category.entity.sand.button.cycle=Cycle Block
+model.category.entity.creeper.button.charged=Charged: %s
+model.category.entity.armored_zombie.button.sword=Sword: %s
+model.category.entity.wolf.button.tamed=Tamed: %s
+model.category.entity.wolf.button.sitting=Sitting: %s
+model.category.entity.wolf.button.angry=Angry: %s
+model.category.entity.wolf.button.armor=Armor: %s
+model.category.entity.wolf.button.item=Item: %s
+model.category.entity.boat.button.flag=Flag: %s
+model.category.entity.boat.button.wind=Wind: %s degrees
+model.category.entity.slime.slider.size=Slime: %s
+model.category.entity.minecart.button.cycle=Cycle Minecart
+
+model.category.block.name=Block
+model.category.block.info=Block: %s
+model.category.block.basket.slider.fill=Fill: %s
+model.category.block.spawner.button.id=Mob: %s
+
+model.category.particle.name=Particle
+model.category.particle.info=Particle: %s
+model.category.particle.radius.slider=Radius: %s
+model.category.particle.note.slider=Note: %s
\ No newline at end of file
diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index ddaaf49d2..e66e80d74 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -286,6 +286,8 @@ item.dust.sugar.name=Sugar
 item.dust.sugar.desc=Can craft sweet treats.
 item.food.cake.name=Cake
 item.food.cake.desc=Not a lie!
+item.food.pumpkin_pie.name=Pumpkin Pie
+item.food.pumpkin_pie.desc=Thanks!
 item.bed.name=Bed
 item.bed.desc=Take a nap overnight.
 item.repeater.name=Redstone Repeater
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 9da21c214..1217a7a19 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -141,6 +141,10 @@ options.flightSmoothness=Flight Smoothness
 options.customAnimations=Custom Animations
 options.turnWithVehicle=Turn with Vehicle
 options.playServerSounds=Play Server Sounds
+options.lightmapStyle=Lightmap Style
+options.lightmapStyle.default=Default
+options.lightmapStyle.cosy=Cosy
+options.lightmapStyle.disabled=Disabled
 
 options.tooltipStyle.default=Default
 options.tooltipStyle.modern=Modern
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 858e62a38..d32b21f04 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -8,10 +8,11 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Random;
 
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -65,6 +66,7 @@ import net.minecraft.client.render.EffectRenderer;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.LoadingScreenRenderer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.PostProcessingManager;
@@ -147,11 +149,12 @@ public class Minecraft
 {
     public static final String VERSION = Global.VERSION;
     public static final boolean isMultiplayerDisabled = false;
+    public static boolean doPartialTick = true;
     private static Minecraft INSTANCE;
     public PlayerController playerController;
     public boolean hasCrashed;
     public UnexpectedThrowable lastCrash;
-    private Timer timer;
+    private final Timer timer;
     public World theWorld;
     public RenderGlobal renderGlobal;
     public EntityPlayerSP thePlayer;
@@ -772,7 +775,7 @@ public class Minecraft
                     Vec3d.initializePool();
                     
                     if(Display.isCloseRequested()) shutdown();
-                    if(isGamePaused && theWorld != null)
+                    if(isGamePaused && theWorld != null && !(currentScreen instanceof GuiModelViewer))
                     {
                         float temp = timer.partialTicks;
                         timer.advanceTime();
@@ -781,6 +784,7 @@ public class Minecraft
                     {
                         timer.advanceTime();
                     }
+                    if (!doPartialTick) timer.partialTicks = 1f;
                     long nanoTime = System.nanoTime();
 
                     mouseInput.update();
@@ -1360,7 +1364,9 @@ public class Minecraft
                                     if (profile != null && profile.isOperator)
                                     {
                                         fullbright = !fullbright;
-                                        renderGlobal.loadRenderers();
+                                        if(!LightmapHelper.isLightmapEnabled()) {
+                                        	renderGlobal.loadRenderers();	
+                                        }
                                     }
                                 }
                                 else
@@ -1368,7 +1374,9 @@ public class Minecraft
                                     if (theWorld.getLevelData().getCheatsEnabled())
                                     {
                                         fullbright = !fullbright;
-                                        renderGlobal.loadRenderers();
+                                        if(!LightmapHelper.isLightmapEnabled()) {
+                                        	renderGlobal.loadRenderers();	
+                                        }
                                     }
                                 }
                                 ingameGUI.guiHeldItemTooltip.setString("Fullbright: " + (fullbright ? "On" : "Off"));
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityBubbleFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityBubbleFX.java
index d64ca9cdc..acd4bc5c7 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityBubbleFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityBubbleFX.java
@@ -10,11 +10,13 @@ import net.minecraft.core.world.World;
 
 public class EntityBubbleFX extends EntityFX
 {
+    private final boolean needsWater;
 
     public EntityBubbleFX(World world, double d, double d1, double d2,
-                          double d3, double d4, double d5)
+                          double d3, double d4, double d5, boolean needsWater)
     {
         super(world, d, d1, d2, d3, d4, d5);
+        this.needsWater = needsWater;
         particleRed = 1.0F;
         particleGreen = 1.0F;
         particleBlue = 1.0F;
@@ -38,7 +40,7 @@ public class EntityBubbleFX extends EntityFX
         xd *= 0.85D;
         yd *= 0.85D;
         zd *= 0.85D;
-        if(world.getBlockMaterial(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) != Material.water)
+        if(needsWater && world.getBlockMaterial(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) != Material.water)
         {
             remove();
         }
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
index 900235783..e88af6d34 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityDiggingFX.java
@@ -20,7 +20,7 @@ public class EntityDiggingFX extends EntityFX
         this.side = Side.getSideById(i);
         this.block = block;
         particleTexture = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(side, meta);
-        this.particleGravity = block.blockParticleGravity;
+        this.particleGravity = block != null ? block.blockParticleGravity : 0;
         this.particleRed = particleGreen = particleBlue = 0.6F;
         this.particleScale /= 2.0F;
 
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
index 024e9ff7d..a2a923c92 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityFX.java
@@ -23,6 +23,9 @@ public class EntityFX extends Entity
         setSize(0.2F, 0.2F);
         heightOffset = bbHeight / 2.0F;
         setPos(x, y, z);
+        xo = this.x;
+        yo = this.y;
+        zo = this.z;
         particleRed = particleGreen = particleBlue = 1.0F;
         this.xd = motionX + (double)((float)(java.lang.Math.random() * 2D - 1.0D) * 0.4F);
         this.yd = motionY + (double)((float)(java.lang.Math.random() * 2D - 1.0D) * 0.4F);
diff --git a/src/main/java/net/minecraft/client/gui/GuiButton.java b/src/main/java/net/minecraft/client/gui/GuiButton.java
index bc1eb8450..2c910ffbe 100644
--- a/src/main/java/net/minecraft/client/gui/GuiButton.java
+++ b/src/main/java/net/minecraft/client/gui/GuiButton.java
@@ -20,6 +20,7 @@ public class GuiButton extends Gui implements GuiElement
     public int id;
     public boolean enabled;
     public boolean visible;
+    public boolean playSound = true;
     public Listener<GuiButton> listener;
 
     public GuiButton(int id, int xPosition, int yPosition, String text)
diff --git a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
index 949d03579..780b5760c 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
+++ b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
@@ -30,7 +30,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 		xSize = 298;
 		container = (ContainerPlayerCreative)entityplayer.inventorySlots;
 		armourValuesFloat = 186;
-		armourButtonFloatX = 76;
+		armourButtonFloatX = 81;
 		overlayButtonsLayout.setOffset(-(xSize / 2), -(ySize / 2) - 10);
 	}
 	
diff --git a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java b/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
index 4c9022154..554d88199 100644
--- a/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
+++ b/src/main/java/net/minecraft/client/gui/GuiMainMenu.java
@@ -16,8 +16,8 @@ import java.util.Random;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.core.Global;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -169,6 +169,9 @@ public class GuiMainMenu extends GuiScreen
         controlList.add(new GuiClickableLabel(6, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.minecraft_forum"), 0x63A121));
         controlList.add(new GuiClickableLabel(7, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFF0000));
         controlList.add(new GuiTexturedButton(8, "/gui/gui.png", width / 2 + 104, i + 72 + 12, 0, 86, 20, 20));
+        GuiButton debugButton = new GuiButton(9, width - 8, height - 8, 8, 8, "");
+        debugButton.visible = false;
+        controlList.add(debugButton);
         if(mc.session == null)
         {
             multiplayerButton.enabled = false;
@@ -207,6 +210,9 @@ public class GuiMainMenu extends GuiScreen
         {
             mc.displayGuiScreen(new GuiOptions(this, OptionsPages.LANGUAGE));
         }
+        if(button.id == 9){
+            mc.displayGuiScreen(new GuiOptions(this, OptionsPages.DEBUG));
+        }
         Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
         if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE))
         {
diff --git a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java b/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
index 3b963bea7..6a2a46539 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPaintingPicker.java
@@ -88,26 +88,26 @@ public class GuiPaintingPicker
 
         artEntries.clear();
 
-        artEntries.add(new ArtEntry(centerArt, centerX - offsetX, centerY - (centerArt.sizeY / 2) * scale, 1.0f));
+        artEntries.add(new ArtEntry(centerArt, centerX - offsetX, centerY - ((centerArt.sizeY  * scale) / 2), 1.0f));
 
         ArtType currentArt = ArtType.getNext(centerArt);
 
-        int dy = (centerArt.sizeY / 2 + artGap) * scale + 22;
+        int dy = ((centerArt.sizeY * scale) / 2 + artGap) + 28;
         while (currentArt != centerArt)
         {
             int pCenterY = dy;
             float alpha = 1 - (float) pCenterY / (height / 2f);
 
             artEntries.add(new ArtEntry(currentArt, centerX - offsetX, centerY + dy, alpha * 0.75f));
-            dy += (currentArt.sizeY + artGap) * scale;
+            dy += ((currentArt.sizeY * scale) + artGap);
             currentArt = ArtType.getNext(currentArt);
         }
 
         currentArt = ArtType.getPrevious(centerArt);
-        dy = -(centerArt.sizeY / 2) * scale;
+        dy = -((centerArt.sizeY  * scale) / 2);
         while (currentArt != centerArt)
         {
-            dy -= (currentArt.sizeY + artGap) * scale;
+            dy -= ((currentArt.sizeY  * scale) + artGap);
             int pCenterY = dy + currentArt.sizeY * scale;
             float alpha = 1 - (float) -pCenterY / (height / 2f);
 
@@ -136,13 +136,17 @@ public class GuiPaintingPicker
         {
             if (entry.alpha > 0)
             {
+                GL11.glColor4f(1f, 1f, 1f, 1f);
                 if (mouseX > entry.x && mouseX < entry.x + entry.art.sizeX * scale && mouseY > entry.y && mouseY < entry.y + entry.art.sizeY * scale)
                 {
                     GL11.glDisable(GL11.GL_TEXTURE_2D);
                     drawRectWidthHeight(entry.x - scale, entry.y - scale, (entry.art.sizeX + 2) * scale, (entry.art.sizeY + 2) * scale, 0xFFFFFFFF);
                     GL11.glEnable(GL11.GL_TEXTURE_2D);
+                    drawPainting(entry.art, entry.x, entry.y, entry.art.sizeX, entry.art.sizeY, 1f);
+                } else {
+                    drawPainting(entry.art, entry.x, entry.y, entry.art.sizeX, entry.art.sizeY, entry.alpha);
                 }
-                drawPainting(entry.art, entry.x, entry.y, entry.art.sizeX, entry.art.sizeY, entry.alpha);
+
             }
         }
 
@@ -160,7 +164,7 @@ public class GuiPaintingPicker
     {
         coordinate.parentAtlas.bindTexture();
         TessellatorStandard tessellator = TessellatorStandard.instance;
-        tessellator.setColorRGBA_F(1f, 1f, 1f, alpha);
+        GL11.glColor4f(1f, 1f, 1f, alpha);
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x + 0,      y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
         tessellator.addVertexWithUV(x + width,  y + height, zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
diff --git a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
index 3835b0282..aa7c17200 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
@@ -38,24 +38,24 @@ public class GuiPhotoMode extends GuiScreen
 
     public boolean showPlayer = true;
 
-    private float iRotation = 0;
-    private float lastIRotation = 0;
-    private float iRotationGoal = 0;
-    private float iZoom = 1;
-    private float lastIZoom = 1;
-    private float iZoomGoal = 1;
-    private float iTilt = 30;
-    private float lastITilt = 30;
-    private float iTiltGoal = 30;
+    protected float iRotation = 0;
+    protected float lastIRotation = 0;
+    protected float iRotationGoal = 0;
+    protected float iZoom = 1;
+    protected float lastIZoom = 1;
+    protected float iZoomGoal = 1;
+    protected float iTilt = 30;
+    protected float lastITilt = 30;
+    protected float iTiltGoal = 30;
     private float iFog = 1;
     private float lastIFog = 1;
     private float iFogGoal = 1;
-    private float iPanX = 0;
-    private float lastIPanX = 0;
-    private float iPanXGoal = 0;
-    private float iPanY = 0;
-    private float lastIPanY = 0;
-    private float iPanYGoal = 0;
+    protected float iPanX = 0;
+    protected float lastIPanX = 0;
+    protected float iPanXGoal = 0;
+    protected float iPanY = 0;
+    protected float lastIPanY = 0;
+    protected float iPanYGoal = 0;
 
     private boolean isMouseDown = false;
     private int mouseButton;
@@ -67,13 +67,13 @@ public class GuiPhotoMode extends GuiScreen
 
     public float intensityValue = 1.0f;
 
-    boolean shouldScreenshot = false;
+    protected boolean shouldScreenshot = false;
     
-    private PhotoModeRenderer photoModeRenderer;
+    protected PhotoModeRenderer photoModeRenderer;
     
     public Renderer previousRenderer;
     
-    private boolean showHelpText = true;
+    protected boolean showHelpText = true;
 
     public GuiPhotoMode()
     {
@@ -306,7 +306,7 @@ public class GuiPhotoMode extends GuiScreen
         }
     }
 
-    private long lastUpdateTime = 0;
+    protected long lastUpdateTime = 0;
     @Override
     public void drawScreen(int mouseX, int mouseY, float partialTick)
     {
diff --git a/src/main/java/net/minecraft/client/gui/GuiScreen.java b/src/main/java/net/minecraft/client/gui/GuiScreen.java
index e35388b83..0643984d7 100644
--- a/src/main/java/net/minecraft/client/gui/GuiScreen.java
+++ b/src/main/java/net/minecraft/client/gui/GuiScreen.java
@@ -73,7 +73,7 @@ public class GuiScreen extends Gui
         if(mouseButton == 0)
         {
             for (GuiButton guiButton : controlList) {
-                if (guiButton.mouseClicked(mc, mouseX, mouseY)) {
+                if (guiButton.mouseClicked(mc, mouseX, mouseY) && guiButton.playSound) {
                     selectedButton = guiButton;
                     mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                     if (guiButton.listener != null) {
diff --git a/src/main/java/net/minecraft/client/gui/GuiTextField.java b/src/main/java/net/minecraft/client/gui/GuiTextField.java
index f9be61b70..140320b76 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTextField.java
+++ b/src/main/java/net/minecraft/client/gui/GuiTextField.java
@@ -5,7 +5,6 @@ import net.minecraft.client.render.FontRenderer;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.gui.text.ITextField;
-import org.lwjgl.opengl.GL11;
 
 public class GuiTextField extends Gui implements ITextField
 {
@@ -163,7 +162,7 @@ public class GuiTextField extends Gui implements ITextField
     public void setTextChangeListener(ITextChangeListener textChangeListener) {
 		this.textChangeListener = textChangeListener;
 	}
-    
+
     public interface ITextChangeListener
     {
     	void textChanged(GuiTextField textField);
